Overview | Package | Class | Deprecated | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## net.sf.saxon.om
Class SingleNodeIterator

    java.lang.Object
      net.sf.saxon.om.SingleNodeIterator

All Implemented Interfaces:
  LastPositionFinder, ReversibleIterator, AxisIterator, GroundedIterator, LookaheadIterator, SequenceIterator, UnfailingIterator

    public class SingleNodeIterator

extends Object
implements AxisIterator, UnfailingIterator, ReversibleIterator, LastPositionFinder, GroundedIterator, LookaheadIterator

SingletonIterator: an iterator over a sequence of zero or one values

Field Summary

Fields inherited from interface net.sf.saxon.om.SequenceIterator
`GROUNDED, LAST_POSITION_FINDER, LOOKAHEAD`

Method Summary
`Value` | `atomize()` Return the atomized value of the current node.
`Item` | `current()` Get the current value in the sequence (the one returned by the most recent call on next()).
`SequenceIterator` | `getAnother()` Get another SequenceIterator that iterates over the same items as the original, but which is repositioned at the start of the sequence.
`int` | `getLastPosition()` Get the last position (that is, the number of items in the sequence).
`int` | `getProperties()` Get properties of this iterator, as a bit-significant integer.
`SequenceIterator` | `getReverseIterator()` Get a new SequenceIterator that returns the same items in reverse order.
`CharSequence` | `getStringValue()` Return the string value of the current node.
`Item` | `getValue()`
`boolean` | `hasNext()` Determine whether there are more items to come.
`AxisIterator` | `iterateAxis(byte axis, NodeTest test)` Return an iterator over an axis, starting at the current node.
`static AxisIterator` | `makeIterator(NodeInfo item)` Factory method.
`Value` | `materialize()` Return a Value containing all the items in the sequence returned by this SequenceIterator
`boolean` | `moveNext()` Move to the next node, without returning it.
`Item` | `next()` Get the next item in the sequence.
`int` | `position()` Return the current position in the sequence.

Methods inherited from class java.lang.Object
`equals, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Method Detail

### makeIterator

    public static AxisIterator makeIterator(NodeInfo item)

  Factory method.

  Parameters:
    `item` - the item to iterate over
  Returns:
    a SingletonIterator over the supplied item, or an EmptyIterator if the supplied item is null.

### hasNext

    public boolean hasNext()

  Determine whether there are more items to come. Note that this operation is stateless and it is not necessary (or usual) to call it before calling next(). It is used only when there is an explicit need to tell if we are at the last element.

  Specified by:
    `hasNext` in interface `LookaheadIterator`
  Returns:
    true if there are more items

### moveNext

    public boolean moveNext()

  Move to the next node, without returning it. Returns true if there is a next node, false if the end of the sequence has been reached. After calling this method, the current node may be retrieved using the current() function.

  Specified by:
    `moveNext` in interface `AxisIterator`

### next

    public Item next()

  Description copied from interface: `SequenceIterator`
  Get the next item in the sequence. This method changes the state of the iterator, in particular it affects the result of subsequent calls of position() and current().

  Specified by:
    `next` in interface `SequenceIterator`
  Specified by:
    `next` in interface `UnfailingIterator`
  Returns:
    the next item, or null if there are no more items. Once a call on next() has returned null, no further calls should be made. The preferred action for an iterator if subsequent calls on next() are made is to return null again, and all implementations within Saxon follow this rule.

### current

    public Item current()

  Description copied from interface: `SequenceIterator`
  Get the current value in the sequence (the one returned by the most recent call on next()). This will be null before the first call of next(). This method does not change the state of the iterator.

  Specified by:
    `current` in interface `SequenceIterator`
  Specified by:
    `current` in interface `UnfailingIterator`
  Returns:
    the current item, the one most recently returned by a call on next(). Returns null if next() has not been called, or if the end of the sequence has been reached.

### position

    public int position()

  Return the current position in the sequence.

  Specified by:
    `position` in interface `SequenceIterator`
  Specified by:
    `position` in interface `UnfailingIterator`
  Returns:
    0 before the first call on next(); 1 before the second call on next(); -1 after the second call on next().

### getLastPosition

    public int getLastPosition()

  Description copied from interface: `LastPositionFinder`
  Get the last position (that is, the number of items in the sequence). This method is non-destructive: it does not change the state of the iterator. The result is undefined if the next() method of the iterator has already returned null. This method must not be called unless the result of getProperties() on the iterator includes the bit setting `SequenceIterator.LAST_POSITION_FINDER`

  Specified by:
    `getLastPosition` in interface `LastPositionFinder`

### iterateAxis

    public AxisIterator iterateAxis(byte axis,
                                    NodeTest test)

  Return an iterator over an axis, starting at the current node.

  Specified by:
    `iterateAxis` in interface `AxisIterator`
  Parameters:
    `axis` - the axis to iterate over, using a constant such as `Axis.CHILD`
    `test` - a predicate to apply to the nodes before returning them.

### atomize

    public Value atomize()
                  throws XPathException

  Return the atomized value of the current node.

  Specified by:
    `atomize` in interface `AxisIterator`
  Returns:
    the atomized value.
  Throws:
    `NullPointerException` - if there is no current node
    `XPathException`

### getStringValue

    public CharSequence getStringValue()

  Return the string value of the current node.

  Specified by:
    `getStringValue` in interface `AxisIterator`
  Returns:
    the string value, as an instance of CharSequence.
  Throws:
    `NullPointerException` - if there is no current node

### getAnother

    public SequenceIterator getAnother()

  Description copied from interface: `SequenceIterator`
  Get another SequenceIterator that iterates over the same items as the original, but which is repositioned at the start of the sequence.

  This method allows access to all the items in the sequence without disturbing the current position of the iterator. Internally, its main use is in evaluating the last() function.

  This method does not change the state of the iterator.

  Specified by:
    `getAnother` in interface `SequenceIterator`
  Specified by:
    `getAnother` in interface `UnfailingIterator`
  Returns:
    a SequenceIterator that iterates over the same items, positioned before the first item

### getReverseIterator

    public SequenceIterator getReverseIterator()

  Description copied from interface: `ReversibleIterator`
  Get a new SequenceIterator that returns the same items in reverse order. If this SequenceIterator is an AxisIterator, then the returned SequenceIterator must also be an AxisIterator.

  Specified by:
    `getReverseIterator` in interface `ReversibleIterator`
  Returns:
    an iterator over the items in reverse order

### getValue

    public Item getValue()

### materialize

    public Value materialize()

  Return a Value containing all the items in the sequence returned by this SequenceIterator

  Specified by:
    `materialize` in interface `GroundedIterator`
  Returns:
    the corresponding Value. If the value is a closure or a function call package, it will be evaluated and expanded.

### getProperties

    public int getProperties()

  Get properties of this iterator, as a bit-significant integer.

  Specified by:
    `getProperties` in interface `SequenceIterator`
  Returns:
    the properties of this iterator. This will be some combination of properties such as `SequenceIterator.GROUNDED`, `SequenceIterator.LAST_POSITION_FINDER`, and `SequenceIterator.LOOKAHEAD`. It is always acceptable to return the value zero, indicating that there are no known special properties. It is acceptable for the properties of the iterator to change depending on its state.

Overview | Package | Class | Deprecated | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright (C) Michael H. Kay. All rights reserved.